/* 
 Joan Soler-Adillon
 Realitat Virtual || Realidad Virtual - Processing
 MÃ ster en Arts Digitals, UPF
 http://www.joan.cat/
 */


PVector gravedad;
float valorDeFriccionY, valorDeFriccionX;
int ballsSize = 15;
//cremos ARRAYLIST para guardar las bolas
//sin necesidad de decidir a priori su nÃºmero
ArrayList<ball> bolas = new ArrayList();



void setup() {
  size(500,200);
  //gravedad. De hecho, es un valor de aceleraciÃ³n.
  gravedad = new PVector(0,0.1);
  //y finalmente, un valor de fricciÃ³n, para ir desacelerando la bola a medida que  va tocando el suelo. 
  //Es el valor por el que multiplicaremos la velocidad de la misma.
  valorDeFriccionY = -0.8;
  valorDeFriccionX = -0.8;

  stroke(255,0,0);
  noFill();
}


void draw() {

  background(0);

  //gravedad = new PVector(map(  

  actualizarCursor();
  actualizarBolas();
}

void actualizarCursor() {

  //////CURSOR  //si clicamos
  if(mousePressed) {
    //cambia el cursos
    cursor(HAND);
    //y dibuja una elipse donde estÃ¡ este, para dar la impresiÃ³n que se creÃ³ una y el usuario la tiene 
    ellipse(mouseX,mouseY,ballsSize,ballsSize);
  } 
  else {
    cursor(ARROW);
  }
  //
}

void actualizarBolas() {
  for(int i=0;i<bolas.size();i++) {
    ball b = bolas.get(i);
    b.setAcc(gravedad);
    b.run();
  }
}

//al dejar el mouse
void mouseReleased() {
  //creamos una nueva bola
  ball b = new ball(); 
  //y la aÃ±adimos al Array
  bolas.add(b);
}

//si clicamos una tecla
void keyPressed() {
  //si es ESPACIO, disparamos la bolas para arriba
  if (key==' ') {
    for(int i = 0; i<bolas.size(); i++) {
      ball b = (ball) bolas.get(i);  
      b.myV.x = random(-5,5);
      b.myV.y = random(-8,-0.5);
    }
  } //Si es la C, cambiamos el modo de color
  else if (key=='c') {
    bolas.clear();
  }
}

////////////////////////////////////////////////////////
///////////////// CLASS BOLAS

class ball {

  PVector myP, myV, myAcc; 
  int mySz = 15;

  ball() {
    myP = new PVector(mouseX,mouseY);
    myV = new PVector(mouseX-pmouseX,mouseY-pmouseY);
    myAcc = new PVector(0,0);
  } 

  void run() {
    update();
    drawMe();
  }

  void update() {
       //Añadimos el valor de gravedad (aceleración) a la velocidadocidad y velocidadocidad a posicionición
    myV.add(myAcc);
    myP.add(myV);
   //myAcc.mult(0);


    //comprobamos los bordes X
    if(myP.x<mySz/2) {
      myV.x *= valorDeFriccionX;
      myP.x = mySz/2;
    } 
    else if (myP.x>width-mySz/2) {
      myV.x *= valorDeFriccionX;
      myP.x = width-mySz/2;
    }

    //comprobamos los bordes sÃ³lo por abajo. 
    if (myP.y>height-mySz/2) {
      myV.y *= valorDeFriccionY;
      //para que no se enganche:
      myP.y = height-mySz/2;
    }
  }

  void drawMe() {
    pushMatrix();
    translate(myP.x,myP.y);
    rotate(myV.heading());
    stroke(255,0,0);
    noFill();//(255,0,0);
    line(0,0,-20,0);
     ellipse(0,0,mySz,mySz);
    popMatrix();
  }
  
  //void addForce(PVector _f){
  //   myAcc = _f;
  //}
  void setAcc(PVector _f){
    myAcc = _f; 
  }
}

