int total = 150;
cosa[] cosasList = new cosa[total];
//declaramos variables
PVector gravedad,wind;

void setup() {
  size(500,200);
  //inicializamos variables
  gravedad = new PVector(0,0.1);
  wind = new PVector(0,0);
  for(int i=0; i<total; i++) {
    cosasList[i] = new cosa();
  }
}

void draw() {
  background(0);
  if(mousePressed){
      stroke(255,0,0);
      line(width/2,height/2,mouseX,mouseY);
  }
  stroke(0);
  for(cosa c : cosasList){
    if(mousePressed) {
      //c.attractToMouse();
      float forceOfWind = 0.4;
      wind.set(map(mouseX,0,width,-forceOfWind,forceOfWind),map(mouseY,0,height,-forceOfWind,forceOfWind),0);
      c.addForce(wind);
    } 
    //else {
      PVector grav = gravedad.get();
      grav.mult(c.myMass);
      c.addForce(grav);
    //  c.addForce(f2);
    //}
    c.run();
  }
}

//////////////////////////////////////////7
/////////////////////// CLASE COSA
////////////////////////////////////////
class cosa {

  PVector posicion, velocidad, acceleracion;
  float frictionScaleFactor, mySizeMax, mySizeMin, mySize, myMass;

  cosa() {
    posicion = new PVector(random(width), random(5, 60));
    velocidad = new PVector(0, 0);
    acceleracion = new PVector(0, 0);
    mySizeMin = 5;
    mySizeMax = 50;
    mySize = random(mySizeMin, mySizeMax);
    myMass = map(mySize, mySizeMin, mySizeMax, 1, 2.5);
    frictionScaleFactor = 1.5;//mayor a 1 mejor
  }

  void run() {
    update();
    drawMe();
  }

  void update() {  
    //Añadimos el valor de gravedad (aceleración) a la velocidadocidad y velocidadocidad a posicionición
    velocidad.add(acceleracion);
    //velocidad.limit(2);
    posicion.add(velocidad);
    acceleracion.mult(0);

    //comprobamo los bordes de la ventana
    //en lo horizontal, como siempre
    if (posicion.x < mySize/2) {
      velocidad.x *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      posicion.x = mySize/2;
    } 
    else if (posicion.x > width-mySize/2) {
      velocidad.x *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      posicion.x = width-mySize/2;
    }
    //pero en lo vertical sólo abajo, y reduciendo cada vez la velocidadocidad, para simular fricción.

    if (posicion.y > height-mySize/2) {//||(posicion.y < 0)) {
      velocidad.y *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      //para que no se enganche:
      posicion.y = height-mySize/2;
    } 
    else if (posicion.y - mySize/2 < 0) {
      velocidad.y *= -1;
      velocidad.div(myMass*frictionScaleFactor);//FRICCION
      //para que no se enganche:
      posicion.y = mySize/2;
    }
  }

  void drawMe() {
    //y finalmente, dibujamos
    ellipse(posicion.x, posicion.y, mySize, mySize);
  }

  void addForce(PVector _f) {
    PVector f = PVector.div(_f, myMass);
    acceleracion.add(f);//.add(f);
  }

//  void attractToMouse() {
//    PVector mouseVector = new PVector(mouseX, mouseY);
//    PVector dis = PVector.sub(mouseVector, posicion);
//    dis.normalize();
//    dis.mult(0.5);
//    addForce(dis);
//  }
}

